"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.awaitTimeout = exports.awaitNextTick = exports.awaitAtMost = void 0;
const awaitAtMost = (promise, timeout) => {
    let timeoutId = null;
    const racePromise = Promise.race([
        promise,
        new Promise(resolve => (timeoutId = setTimeout(() => {
            timeoutId = null;
            resolve();
        }, timeout))),
    ]);
    racePromise.finally(() => (timeoutId ? clearTimeout(timeoutId) : undefined));
    return racePromise;
};
exports.awaitAtMost = awaitAtMost;
const awaitNextTick = () => {
    return new Promise(r => process.nextTick(r));
};
exports.awaitNextTick = awaitNextTick;
const awaitTimeout = (timeout) => {
    return new Promise(r => setTimeout(r, timeout));
};
exports.awaitTimeout = awaitTimeout;
//# sourceMappingURL=util.js.map